Attribute VB_Name = "DMO_VBX"
Option Explicit

Rem ******* Define global constants for the demo program
Global Const MAX_FORMS = 100 ' this demo handles 100 forms
Global Const MAX_FILES = 2   ' this demo uses 2 data files
Global Const MAX_FIELDS = 15 ' the demo data files have 15 fields max

Global Const CHECKED = 1     ' button checked
Global Const UNCHECKED = 0   ' button not checked

Global DlgResult As Integer   ' result from a dialog box call

Global ErrorCode As Integer   ' error code

Rem ******** Define global variables ******************
Global FormParm As TypeForm      ' form editor input structure
Global RepParm  As TypeRep       ' report executer input structure
Global ViewParm As TypeView      ' report viewer parameter structure

Global FormName(100) As String   ' form name array
Global FormFile(100) As String   ' form file name array
Global TotalForms As Integer     ' total forms in the listbox
Global NewReport As Integer      ' index of the new report in the list box
Global CurFile As Integer        ' selected file
Global SalesFileUsed As Integer  ' True if SALES file is used

Global GetSortField As Integer   ' True to get sort fields

Type TypeDataFile             ' stores name and total fields for each data file
    name As String '* 13          ' data file name
    TotalFields As Integer    ' total fields in the data file
End Type

Global DataFile(2) As TypeDataFile ' Names and total fields for each data file

Type TypeDataField
     ShortName As String '* 15  ' field short name
     FullName As String '* 35   ' full name
     width As Integer           ' field width in number of characters
     type  As Integer           ' field types, see TYPE_ constants in the REP.BAS file
     DecPlaces As Integer       ' number of integer places for a numeric field
End Type

Global DataField(2, 15) As TypeDataField ' store field information for each field for both files

Global RepFieldSource(500) As Integer     ' field source for each report field
Global RepFieldType(500) As Integer        ' field type for each report field
Global RepFileId(500) As Integer           ' file id for each report field
Global RepFieldId(500) As Integer          ' field id for each report field

Public Function PrintProgress(ByVal ReportId As Long, ByVal PagesPrinted As Long, Cancel As Long) As Boolean
    Debug.Print "pages printed: ", PagesPrinted
    'If (PagesPrinted = 1) Then Cancel = 1
End Function
  
Public Function DrawPictureDirect(ByVal ReportId As Long) As Boolean
   Dim PictInfo As TypeRvdPict
   Dim temp As Integer
   Dim PictWidth As Integer
   Dim PictX As Integer
   Dim PictY As Integer
   Dim PictHeight As Integer
   Dim PictFile As String
   
   ' get the report device context and picture rectangle
   temp = RvdGetPictureInfo(ReportId, PictInfo)
    
   If PictInfo.FieldId = 11 Then ' draw a bitmap
     ' specify part of the bitmap to print as a percentage of the width and height
     If PictInfo.PictId < 1 Then PictInfo.PictId = 1
     If PictInfo.PictId > 10 Then PictInfo.PictId = 10
   
     PictX = (PictInfo.PictId - 1) * 10  'starting X location
     PictWidth = 10               'always print only 10 percent of the bitmap
     PictY = 0
     PictHeight = 100             ' print the entire height

     ' The following statment uses the RvbDrawBitmap function
     ' to draw a part of the logo.bmp file.  The logo.bmp
     ' bitmap file is loaded into the 'Picture1' control.
     ' The 'AutoSize' property of the picture control MUST
     ' be TRUE so that the control does not clip the
     ' bitmap.

     temp = RvdDrawBitmap(ReportId, main.Picture1.hWnd, RvdPictureListGet(RepParm.ReportId, "key1"), PictX, PictY, PictWidth, PictHeight)
     
   ElseIf PictInfo.FieldId = 12 Then ' Draw an RTF memo field
      
     If PictInfo.PictId = 1 Then PictFile = "letter1.rtf" Else PictFile = "letter2.rtf"
     temp = RepDrawTerText(ReportId, PictFile + Chr(0), 0, 0, ByVal 0&, ByVal 0&)
   End If

   DrawPictureDirect = True
   
End Function

